Imports CookComputing.XmlRpc

Namespace Blogger
    Public Structure Category
        Public categoryid As String
        Public title As String
        Public description As String
        Public htmlUrl As String
        Public rssUrl As String
    End Structure

    Public Structure Post
        Public dateCreated As DateTime
        <XmlRpcMember(Description:="Depending on server may either be string or integer. Use Convert.ToInt32(userid) to treate as integer or Convert.ToString(userid) to treate as string."), _
         XmlRpcMissingMapping(MappingAction.Ignore)> _
        Public userid As Object
        <XmlRpcMissingMapping(MappingAction.Ignore)> _
        Public postid As String
        Public content As String
    End Structure

    Public Structure UserInfo
        Public url As String
        Public email As String
        Public nickname As String
        Public lastname As String
        Public firstname As String
    End Structure

    Public Structure BlogInfo
        Public blogid As String
        Public url As String
        Public blogname As String
    End Structure

    Public Interface IBlogger
        <XmlRpcMethod("blogger.deletePost", Description:="Deletes a post. Always returns true.")> _
        Function deletePost( _
            ByVal appKey As String, _
            ByVal postid As String, _
            ByVal username As String, _
            ByVal password As String, _
            ByVal publish As Boolean) As Boolean

        <XmlRpcMethod("blogger.editPost", Description:="Edis a given post. Optionally will publish the blog after making the edit. Always returns true")> _
        Function editPost( _
            ByVal appKey As String, _
            ByVal postid As String, _
            ByVal username As String, _
            ByVal password As String, _
            ByVal content As String, _
            ByVal publish As Boolean) As Object

        <XmlRpcMethod("blogger.getCategories", Description:="returns a list of the categories that you can use to log against a post.")> _
        Function getCategories( _
            ByVal blogid As String, _
            ByVal username As String, _
            ByVal password As String) As Category()

        <XmlRpcMethod("bloggger.getPost", Description:="Returns a single post.")> _
        Function getPost( _
            ByVal appKey As String, _
            ByVal postid As String, _
            ByVal username As String, _
            ByVal password As String) As Post


        <XmlRpcMethod("blogger.getRecentPosts", Description:="Returns a list of the most recent posts in the system.")> _
        Function getRecentPosts( _
            ByVal appKey As String, _
            ByVal blogid As String, _
            ByVal username As String, _
            ByVal password As String, _
            ByVal numberOfPosts As Integer) As Post()


        <XmlRpcMethod("blogger.getTemplate", Description:="Returns the main or archive index template of a given blog.")> _
        Function getTemplate( _
            ByVal appKey As String, _
            ByVal blogid As String, _
            ByVal username As String, _
            ByVal password As String, _
            ByVal templateType As String) As String

        <XmlRpcMethod("blogger.getUserInfo", Description:="Authenticates a user and returns basic user info (name, email, userid, etc).")> _
        Function getUserInfo( _
            ByVal appKey As String, _
            ByVal username As String, _
            ByVal password As String) As UserInfo

        <XmlRpcMethod("blogger.getUsersBlogs", Description:="Returns information on all of the blogs a given user is a member.")> _
        Function getUsersBlogs( _
            ByVal appKey As String, _
            ByVal username As String, _
            ByVal password As String) As BlogInfo()

        <XmlRpcMethod("blogger.newPost", Description:="Makes a new post to a designated blog, Optionally, will bublish the blog after making the post. REturns Id of new post")> _
        Function newPost( _
            ByVal appKey As String, _
            ByVal blogid As String, _
            ByVal username As String, _
            ByVal password As String, _
            ByVal content As String, _
            ByVal publish As Boolean) As String

        <XmlRpcMethod("blogger.setTemplate", Description:="Edits the main or archive index template of a given blog.")> _
        Function setTempalte( _
            ByVal appKey As String, _
            ByVal blogid As String, _
            ByVal username As String, _
            ByVal password As String, _
            ByVal template As String, _
            ByVal templateType As String) As Boolean

    End Interface

End Namespace