﻿Option Strict On
Option Infer On

Imports System.ServiceModel.Syndication

Imports LinqBlog.BO

Public Module Importer
    Public Sub ImportFeedNew()
        Dim feed As SyndicationFeed = SyndicationFeed.Load(New System.Xml.XmlTextReader("http://devauthority.com/blogs/jwooley/rss.aspx"))
        Dim dc As New LinqBlogDataContext()
        dc.PostItems.InsertAllOnSubmit(From p In feed.Items _
                            Select New PostItem With {.Author = If(p.Authors.Count > 0, p.Authors(0).Name, "Jim Wooley"), _
                                                      .Description = p.Summary.Text, _
                                                      .PublicationDate = p.PublishDate.Date, _
                                                      .Title = p.Title.Text})

    End Sub
    Public Sub ImportFeed()
        Dim Feed As System.Xml.Linq.XDocument = XDocument.Load("http://devauthority.com/blogs/jwooley/rss.aspx")
        
        Dim dc As New LinqBlogDataContext()

        Dim Categories = (From c In dc.Categories _
            Select c).ToArray

        dc.PostItems.InsertAllOnSubmit(From post In Feed...<item> _
                            Select New PostItem With { _
                                .Author = "Jim Wooley", _
                                .Description = post.<description>.Value, _
                                .PublicationDate = CDate(post.<pubDate>.Value), _
                                .Title = post.<title>.Value})

        ', _
        '        ' Get categories as well
        '        For Each c As XElement In post...<Category>
        '            Dim cat = (From dbCat In dc.Categories _
        '                Where dbCat.Description = c.Value _
        '                Select dbCat).Single
        '            If Not cat Is Nothing Then
        '                Dim catPost As New CategoryPost
        '                catPost.CategoryID = cat.CategoryId
        '                catPost.PostId = DataPost.Id
        '                DataPost.CategoryPosts.Add(catPost)
        '            End If
        '        Next
        '        dc.PostItems.Add(DataPost)
        '        Console.WriteLine(DataPost.Title)
        '        Next

        dc.SubmitChanges()

        Console.WriteLine()
        Console.ReadLine()
    End Sub
End Module
