Public Class Employee
    Private _EmployeeId As String = ""
    Private _LastName As String = ""
    Private _FirstName As String = ""
    Private _City As String = ""
    Private _Country As String = ""

    'Child collection
    Private _OrderList As New List(Of OrderItem)

    Public Sub New()
        'prevent direct instantiation
    End Sub

    Public ReadOnly Property EmployeeId() As String
        Get
            Return _EmployeeId
        End Get
    End Property

    Public Property LastName() As String
        Get
            Return _LastName
        End Get
        Set(ByVal value As String)
            _LastName = value
        End Set
    End Property

    Public Property FirstName() As String
        Get
            Return _FirstName
        End Get
        Set(ByVal value As String)
            _FirstName = value
        End Set
    End Property

    Public Property City() As String
        Get
            Return _City
        End Get
        Set(ByVal value As String)
            _City = value
        End Set
    End Property

    Public Property Country() As String
        Get
            Return _Country
        End Get
        Set(ByVal value As String)
            _Country = value
        End Set
    End Property

    Public ReadOnly Property Orders() As List(Of OrderItem)
        Get
            Return _OrderList
        End Get
    End Property

    Friend Shared Function GetEmployee(ByVal dr As SqlClient.SqlDataReader) As Employee
        Dim child As New Employee
        child.Fetch(dr)
        Return child
    End Function

    Private Sub Fetch(ByVal dr As SqlClient.SqlDataReader)
        With dr
            _EmployeeId = dr.GetInt32(0).ToString
            _LastName = dr.GetString(1)
            _FirstName = dr.GetString(2)
            _City = dr.GetString(3)
            _Country = dr.GetString(4)
        End With
    End Sub
End Class

Public Class EmployeeList
    Inherits List(Of Employee)

    Private Sub New()
        'Force instance through factory
    End Sub

    Public ReadOnly Property ItemById(ByVal employeeId As String) As Employee
        Get
            For Each child As Employee In Me
                If child.EmployeeId = employeeId Then Return child
            Next
            'Not Found
            Return Nothing
        End Get
    End Property

    Public Shared Function GetEmployeeList() As EmployeeList
        Dim Employees As New EmployeeList
        Employees.Fetch(False)
        Return Employees
    End Function

    Public Shared Function GetEmployeeOrderList() As EmployeeList
        Dim Employees As New EmployeeList
        Employees.Fetch(True)
        Return Employees
    End Function

    Private Sub Fetch(ByVal loadChildren As Boolean)
        Using cn As New Data.SqlClient.SqlConnection("Data Source=.\SQLEXPRESS;AttachDbFilename=C:\Projects\Data\NORTHWND.MDF;Integrated Security=True;Connect Timeout=30;User Instance=True")
            cn.Open()
            Using cmCustomer As New Data.SqlClient.SqlCommand("Select EmployeeId, LastNAme, FirstName, City, Country from Employees", cn)
                Using dr As Data.SqlClient.SqlDataReader = cmCustomer.ExecuteReader
                    While dr.Read
                        Me.Add(Employee.GetEmployee(dr))
                    End While
                End Using 'dr
            End Using 'cmCustomer
            If loadChildren Then
                Using cmOrder As New Data.SqlClient.SqlCommand("Select * from Orders", cn)
                    Using dr As Data.SqlClient.SqlDataReader = cmOrder.ExecuteReader
                        While dr.Read
                            'find the customer for this order and add to their order item list
                            Dim emp As Employee = Me.ItemById(dr.GetInt32(dr.GetOrdinal("EmployeeId")).ToString)
                            emp.Orders.Add(OrderItem.GetOrder(dr))
                        End While
                    End Using
                End Using
            End If
            cn.Close()
        End Using 'cn
    End Sub
End Class
