Public Class OrderItem
    Private _OrderId As Integer
    Private _CustomerId As String
    Private _EmployeeId As Integer
    Private _OrderDate As Date
    Private _RequiredDate As Date
    Private _ShippedDate As Date
    Private _ShipVia As Integer
    Private _Freight As Decimal
    Private _ShipName As String
    Private _ShipAddress As String
    Private _ShipCity As String
    Private _ShipRegion As String = ""
    Private _ShipPostalCode As String
    Private _ShipCountry As String

    Public Property OrderID() As Integer
        Get
            Return _OrderId
        End Get
        Set(ByVal value As Integer)
            _OrderId = value
        End Set
    End Property

    Public Property CustomerID() As String
        Get
            Return _CustomerId
        End Get
        Set(ByVal value As String)
            _CustomerId = value
        End Set
    End Property

    Public Property EmployeeID() As Integer
        Get
            Return _EmployeeId
        End Get
        Set(ByVal value As Integer)
            _EmployeeId = value
        End Set
    End Property

    Public Property OrderDate() As Date
        Get
            Return _OrderDate
        End Get
        Set(ByVal value As Date)
            _OrderDate = value
        End Set
    End Property

    Public Property RequiredDate() As Date
        Get
            Return _RequiredDate
        End Get
        Set(ByVal value As Date)
            _RequiredDate = value
        End Set
    End Property

    Public Property ShippedDate() As Date
        Get
            Return _ShippedDate
        End Get
        Set(ByVal value As Date)
            _ShippedDate = value
        End Set
    End Property

    Public Property ShipVia() As Integer
        Get
            Return _ShipVia
        End Get
        Set(ByVal value As Integer)
            _ShipVia = value
        End Set
    End Property

    Public Property Freight() As Decimal
        Get
            Return _Freight
        End Get
        Set(ByVal value As Decimal)
            _Freight = value
        End Set
    End Property

    Public Property ShipName() As String
        Get
            Return _ShipName
        End Get
        Set(ByVal value As String)
            _ShipName = value
        End Set
    End Property

    Public Property ShipAddress() As String
        Get
            Return _ShipAddress
        End Get
        Set(ByVal value As String)
            _ShipAddress = value
        End Set
    End Property

    Public Property ShipCity() As String
        Get
            Return _ShipCity
        End Get
        Set(ByVal value As String)
            _ShipCity = value
        End Set
    End Property

    Public Property ShipRegion() As String
        Get
            Return _ShipRegion
        End Get
        Set(ByVal value As String)
            _ShipRegion = value
        End Set
    End Property

    Public Property ShipPostalCode() As String
        Get
            Return _ShipPostalCode
        End Get
        Set(ByVal value As String)
            _ShipPostalCode = value
        End Set
    End Property

    Public Property ShipCountry() As String
        Get
            Return _ShipCountry
        End Get
        Set(ByVal value As String)
            _ShipCountry = value
        End Set
    End Property

    Public Sub New()

    End Sub

    Friend Shared Function GetOrder(ByVal dr As IDataReader) As OrderItem
        Dim child As New OrderItem
        child.Fetch(dr)
        Return child
    End Function

    Private Sub Fetch(ByVal dr As IDataReader)
        With dr
            OrderID = .GetInt32(0)
            CustomerID = .GetString(1)
            EmployeeID = .GetInt32(2)
            OrderDate = .GetDateTime(3)
            RequiredDate = .GetDateTime(4)
            If Not .IsDBNull(5) Then ShippedDate = .GetDateTime(5)
            ShipVia = .GetInt32(6)
            If Not .IsDBNull(7) Then Freight = .GetDecimal(7)
            ShipName = .GetString(8)
            ShipAddress = .GetString(9)
            ShipCity = .GetString(10)
            If Not .IsDBNull(11) Then ShipRegion = .GetString(11)
            If Not .IsDBNull(12) Then ShipPostalCode = .GetString(12)
            ShipCountry = .GetString(13)
        End With
    End Sub
End Class

Public Class OrderList
    Inherits List(Of OrderItem)

    Private Sub New()

    End Sub

    Public Shared Function GetOrderList() As List(Of OrderItem)
        Dim list As New OrderList
        list.FetchData()
        Return list
    End Function

    Private Sub FetchData()
        Dim cn As New Data.SqlClient.SqlConnection("Data Source=.\SQLEXPRESS;AttachDbFilename=C:\Projects\Data\NORTHWND.MDF;Integrated Security=True;Connect Timeout=30;User Instance=True")
        Dim cm As New Data.SqlClient.SqlCommand("Select * from Orders", cn)
        cn.Open()
        Dim dr As Data.SqlClient.SqlDataReader = cm.ExecuteReader
        While dr.Read
            Me.Add(OrderItem.GetOrder(dr))
        End While
        cn.Close()
    End Sub
End Class