﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Query;
using System.Xml.XLinq;
using System.Data.DLinq;

namespace RecipeBO
{
    [Table(Name = "Recipes")]
    public class Recipe
    {
        int _ID;
        string _Title;
        string _Servings;
        EntitySet<Category> _Categories;
        EntitySet<Direction> _Directions;
        EntitySet<Ingredient> _Ingredients;

        [Column(Name = "ID", AutoGen = true, DBType = "Int NOT NULL IDENTITY", Id = true, Storage = "_ID")]
        public int ID
        {
            get { return this._ID; }
            set { this._ID = value; }
        }

        [Column(Name = "Title", Storage = "_Title")]
        public string Title
        {
            get { return _Title; }
            set { _Title = value; }
        }

        [Column(Name = "Serves", Storage = "_Servings")]
        public string NumberOfServings
        {
            get { return _Servings; }
            set { _Servings = value; }
        }

        [System.Data.DLinq.Association(Name = "FK_Categories_Recipes", Storage = "_Categories", OtherKey = "RecipeId")]
        public EntitySet<Category> Categories
        {
            get { return _Categories; }
            set { _Categories.Assign(value); }
        }

        [System.Data.DLinq.Association(Name = "FK_Ingredients_Recipes", Storage = "_Ingredients", OtherKey = "RecipeId")]
        public EntitySet<Ingredient> Ingredients
        {
            get { return _Ingredients; }
            set { _Ingredients.Assign(value); }
        }

        [System.Data.DLinq.Association(Name = "FK_Directions_Recipes", Storage = "_Directions", OtherKey = "RecipeId")]
        public EntitySet<Direction> Directions
        {
            get { return _Directions; }
            set { _Directions.Assign(value); }
        }
    }
}
