﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Query;
using System.Xml.XLinq;
using System.Data.DLinq;
using RecipeBO;
using System.Transactions;

namespace RecipeConsole
{
    class Program
    {
        static void Main(string[] args)
        {

            //Querying();
            //Updates();
            UsingStoredProcs();
            //Transactions();

            Console.WriteLine("Press any key to continue...");
            Console.ReadLine();
        }

        static void Querying()
        {
            RecipeDC dc = RecipeDC.GetContext();
            dc.Log = Console.Out;

            var query = 
                (from r in dc.Recipes
                where r.Title.Contains("Chocolate")
                select r).ToArray();

            ObjectDumper.Write(query.Take(5));
            ObjectDumper.Write(query.Take(5));
        }

        static void Updates()
        {
            RecipeDC dc = RecipeDC.GetContext();
            dc.Log=Console.Out;

            Console.Write("Before change: ");
            Category ChangingCategory = 
                (from c in dc.Categories
                where c.Id==1
                select c).Single<Category>();
            ObjectDumper.Write(ChangingCategory.CategoryName);

            if (ChangingCategory.CategoryName=="Likes it")
            { ChangingCategory.CategoryName="Hates it"; }
            else { ChangingCategory.CategoryName="Likes it" ;}

            Console.WriteLine("Ready to apply change?");
            Console.ReadLine();

            try
            {
            dc.SubmitChanges();
            Console.Write("After change: ");
            ObjectDumper.Write((
                from c in dc.Categories 
                where c.Id==1 
                select c).Single<Category>().CategoryName);
            }
            catch (OptimisticConcurrencyException e) 
            {
                Console.WriteLine("Unable to save. someone else already updated this.");
            }
        }

        static void UsingStoredProcs()
        {
            RecipeDC dc = RecipeDC.GetContext();

            Recipe Editing = (from r in dc.Recipes
                               where r.ID == 1
                               select r).Single<Recipe>();
            ObjectDumper.Write(Editing.Directions);

            Direction NewLine;
            NewLine = new Direction();
            NewLine.RecipeId = Editing.ID;
            NewLine.LineText = String.Format("This line was added at {0}", System.DateTime.Now.ToString());
            Editing.Directions.Add(NewLine);
            dc.SubmitChanges();

            Console.WriteLine("AFTER CHANGE: ");
            ObjectDumper.Write((from r in dc.Recipes
                               where r.ID == 1
                               select r).Single<Recipe>().Directions);

        }

        static void Transactions()
        {
            using (TransactionScope ts = new TransactionScope())
            {
                RecipeDC dc = RecipeDC.GetContext();

                Recipe Editing = (from r in dc.Recipes
                               where r.ID == 1
                               select r).Single<Recipe>();
                ObjectDumper.Write(Editing.Directions);

                Direction NewLine;
                NewLine = new Direction();
                NewLine.RecipeId = Editing.ID;
                NewLine.LineText = String.Format("This line was added at {0}", System.DateTime.Now.ToString());
                Editing.Directions.Add(NewLine);
                dc.SubmitChanges();

                Console.WriteLine("AFTER CHANGE: ");
                ObjectDumper.Write((from r in dc.Recipes
                               where r.ID == 1
                               select r).Single<Recipe>().Directions);

                // Let the transaction roll back
            }
        }


    }

 }
