using System;
using System.Data;
using System.Data.DLinq;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Query;
using RecipeBO;

public partial class Default : System.Web.UI.Page
{
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        RecipeDC dc = RecipeDC.GetContext();
        IEnumerable<Recipe> query =
            from r in dc.Recipes
            where r.Title.Contains(this.txtSearch.Text)
            orderby r.Title
            select r;
        this.ddlTitle.DataSource = query;
        this.ddlTitle.DataBind();
    }

    protected void ddlTitle_SelectedIndexChanged(object sender, EventArgs e)
    {
        RecipeDC dc = RecipeDC.GetContext();

        string value;
        value = ddlTitle.SelectedValue;

        int RecipeId;
        if (int.TryParse(ddlTitle.SelectedValue, out RecipeId))
        {
            pnlDetail.Visible=true;
            Recipe selectedRecipe = (from r in dc.Recipes
                where r.ID == RecipeId
                select r).Single<Recipe>();

            this.txtTitle.Text=selectedRecipe.Title;
            this.txtServes.Text=selectedRecipe.NumberOfServings;

            this.lstCategory.DataSource = selectedRecipe.Categories;
            this.lstCategory.DataBind();

            this.lstDirection.DataSource =
                    from d in selectedRecipe.Directions
                orderby d.LineNumber
                select d;
            this.lstDirection.DataBind();

            this.lstIngredient.DataSource =
                    from i in selectedRecipe.Ingredients
                orderby i.SortOrder
                select i;
            this.lstIngredient.DataBind();
            }
    }
   
}
