<%@ WebHandler Language="VB" Class="LinqBlog.Blogger" %>

Imports System
Imports System.Web
Imports CookComputing.XmlRpc
Imports LinqBlog.BO.Blogger
Imports LinqBlog.BO

Namespace LinqBlog
    
    Public Class Blogger
        Inherits XmlRpcService
        Implements IBlogger
        Implements IHttpHandler
       
#Region " IBlogger "
        Public Function deletePost(ByVal appKey As String, ByVal postid As String, ByVal username As String, ByVal password As String, ByVal publish As Boolean) As Boolean Implements BO.Blogger.IBlogger.deletePost
            ValidateUser(username, password)
            Dim dc As New LinqBlogDataContext
            Dim query = (From p In dc.PostItems _
                Where p.ID = postid _
                Select p)
            Dim post As PostItem = query.Single
            If Not post Is Nothing Then
                dc.PostItems.DeleteOnSubmit(query.Single)
                dc.SubmitChanges()
            End If
            Return True
        End Function

        Public Function editPost(ByVal appKey As String, ByVal postid As String, ByVal username As String, ByVal password As String, ByVal content As String, ByVal publish As Boolean) As Object Implements BO.Blogger.IBlogger.editPost
            ValidateUser(username, password)
            Dim dc As New LinqBlogDataContext
            Dim post = (From p In dc.PostItems _
                Where p.ID = postid _
                Select p).Single
            If Not post Is Nothing Then
                post.Description = content
                dc.SubmitChanges()
            End If
            Return True
        End Function

        Public Function getCategories(ByVal blogid As String, ByVal username As String, ByVal password As String) As BO.Blogger.Category() Implements BO.Blogger.IBlogger.getCategories
            ValidateUser(username, password)

            Dim dc As New LinqBlogDataContext
            Dim cats = _
                From c In dc.Categories _
                Order By c.Title _
                Select New LinqBlog.BO.Blogger.Category With {.categoryid = c.CategoryId, _
                    .title = c.Title, _
                    .description = c.Description, _
                    .htmlUrl = "default?CategoryId=" & c.CategoryId.ToString, _
                    .rssUrl = "rss.aspx?CategoryId=" & c.CategoryId.ToString}
            Return cats.ToArray
            
        End Function

        Public Function getPost(ByVal appKey As String, ByVal postid As String, ByVal username As String, ByVal password As String) As BO.Blogger.Post Implements BO.Blogger.IBlogger.getPost
            ValidateUser(username, password)

            Dim dc As New LinqBlogDataContext
            Dim item As Post = (From p In dc.PostItems _
                Where p.ID = postid _
                Select New Post With {.dateCreated = p.PublicationDate, _
                    .userid = username, _
                    .postid = postid, _
                    .content = p.Description}).Single
            Return item
        End Function

        Public Function getRecentPosts(ByVal appKey As String, ByVal blogid As String, ByVal username As String, ByVal password As String, ByVal numberOfPosts As Integer) As BO.Blogger.Post() Implements BO.Blogger.IBlogger.getRecentPosts
            ValidateUser(username, password)

            Dim dc As New LinqBlogDataContext
            Return (From p In dc.PostItems _
                Order By p.PublicationDate Descending _
                Select New Post With {.dateCreated = p.PublicationDate, _
                    .userid = username, _
                    .postid = p.ID, _
                    .content = p.Description}).Take(numberOfPosts)
            
        End Function

        Public Function getTemplate(ByVal appKey As String, ByVal blogid As String, ByVal username As String, ByVal password As String, ByVal templateType As String) As String Implements BO.Blogger.IBlogger.getTemplate
            ValidateUser(username, password)
            Throw New NotImplementedException
        End Function

        Public Function getUserInfo(ByVal appKey As String, ByVal username As String, ByVal password As String) As BO.Blogger.UserInfo Implements BO.Blogger.IBlogger.getUserInfo
            ValidateUser(username, password)

            Return New UserInfo With {.url = "http://thinklinkq.com", _
                .email = "jimwooley@hotmail.com", _
                .nickname = "Jim", _
                .lastname = "Wooley", _
                .firstname = "Jim"}
            
        End Function

        Public Function getUsersBlogs(ByVal appKey As String, ByVal username As String, ByVal password As String) As BO.Blogger.BlogInfo() Implements BO.Blogger.IBlogger.getUsersBlogs
            ValidateUser(username, password)

            Return New BlogInfo() _
                {New BlogInfo With {.blogid = "1", .url = "http://localhost/LinqBlog/default.aspx", .blogname = "Thinq Linq"}}
            
        End Function

        Public Function newPost(ByVal appKey As String, ByVal blogid As String, ByVal username As String, ByVal password As String, ByVal content As String, ByVal publish As Boolean) As String Implements BO.Blogger.IBlogger.newPost
            ValidateUser(username, password)

            Dim dc As New LinqBlogDataContext
            Dim item As New PostItem
            item.Author = username
            item.Description = content
            item.PublicationDate = Now
            item.Title = "unknown"
            dc.SubmitChanges()
            Return item.ID
                        
        End Function

        Public Function setTempalte(ByVal appKey As String, ByVal blogid As String, ByVal username As String, ByVal password As String, ByVal template As String, ByVal templateType As String) As Boolean Implements BO.Blogger.IBlogger.setTempalte
            ValidateUser(username, password)
            Throw New NotImplementedException
            
        End Function
#End Region
        
        Private Sub ValidateUser(ByVal username As String, ByVal password As String)
            
            '   If Not membership.validateuser(username, password) Then
            ' Throw New XmlRpcFaultException(0, "Invalid username/password")
            ' End If
        End Sub
    End Class
    
End Namespace
