<%@ WebHandler Language="VB" Debug="true" Class="LinqBlog.MetaBlog" %>

Imports System
Imports System.Web
Imports LinqBlog.BO.MetaWeblog
Imports LinqBlog.BO
Imports CookComputing.XmlRpc
Imports System.Collections.Generic
Imports System.Linq

Namespace LinqBlog
    Public Class MetaBlog
        Inherits XmlRpcService
        Implements IMetaWeblog
        Implements IHttpHandler
        
#Region " IMetaWeblog "
        Public Function getUserBlogs() As Blog() Implements IMetaWeblog.getUserBlogs
            Dim item As New Blog
            item.Uri = "//localhost/LinqBlog"
            item.Title = "ThinqLinq"
            Return New Blog() {item}
            
        End Function
        Public Function editPost(ByVal postid As String, ByVal username As String, ByVal password As String, ByVal post As BO.MetaWeblog.Post, ByVal publish As Boolean) As Object Implements IMetaWeblog.editPost
            ValidateUser(username, password)
            Dim dc As New LinqBlog.BO.LinqBlogDataContext
            Dim query as IEnumerable(of  PostItem) = _
                (From p In dc.PostItems _
                Where p.ID = postid _
                Select p)
            
            Dim editing As PostItem = query.Single
            If Not editing Is Nothing Then
                editing.Author = username
                editing.Description = post.description
                editing.PublicationDate = post.dateCreated
                editing.Title = post.title
                dc.SubmitChanges()
                Return True
            Else
                Return False
            End If
        End Function

        Public Function getCategories(ByVal blogid As String, ByVal username As String, ByVal password As String) As BO.MetaWeblog.CategoryInfo() Implements IMetaWeblog.getCategories
            ValidateUser(username, password)
              
            Dim dc As New LinqBlogDataContext
            Dim query = From c In dc.Categories Order By c.Title _
                Select New LinqBlog.BO.MetaWeblog.CategoryInfo With {.description = c.Description, _
                .htmlUrl = "default.aspx?CategoryId=" & c.CategoryId.ToString, _
                .rssurl = "rss.aspx?CategoryId=" & c.CategoryId.ToString, _
                .title = c.Title, _
                .categoryid = c.CategoryId}

            Return query.ToArray
            
        End Function

        Public Function getPost(ByVal postid As String, ByVal username As String, ByVal password As String) As BO.MetaWeblog.Post Implements IMetaWeblog.getPost
            ValidateUser(username, password)
              
            Dim dc As New LinqBlogDataContext
            Dim query = From p In dc.PostItems _
                Where p.ID = postid _
                Select p
            Dim item As PostItem = query.Single
            If Not item Is Nothing Then
                Dim ret As New BO.MetaWeblog.Post
                ret.dateCreated = item.PublicationDate
                ret.description = item.Description
                ret.postid = item.ID
                ret.title = item.Title
                ret.userid = username
                Return ret
            Else
                Return Nothing
            End If
        End Function

        Public Function getRecentPosts(ByVal blogid As String, ByVal username As String, ByVal password As String, ByVal numberOfPosts As Integer) As Post() Implements IMetaWeblog.getRecentPosts
            ValidateUser(username, password)
            Dim dc As New LinqBlogDataContext
            Dim query = From p In dc.PostItems _
                   Order By p.PublicationDate Descending _
                Select New LinqBlog.BO.MetaWeblog.Post _
                    With {.dateCreated = p.PublicationDate, _
                    .description = p.Description, _
                    .title = p.Title, _
                    .permalink = "http://www.thinqlinq.com/Default?Postid=" & p.ID.ToString, _
                    .postid = p.ID, _
                    .userid = username}
            Return query.Take(numberOfPosts)
        End Function

        Public Function newMediaObject(ByVal blogid As String, ByVal username As String, ByVal password As String, ByVal file As BO.MetaWeblog.FileData) As UrlData Implements IMetaWeblog.newMediaObject
            ValidateUser(username, password)
            Throw New NotImplementedException
        End Function

        Public Function newPost(ByVal blogid As String, ByVal username As String, ByVal password As String, ByVal post As BO.MetaWeblog.Post, ByVal publish As Boolean) As String Implements IMetaWeblog.newPost
            ValidateUser(username, password)
            Dim dc As New LinqBlogDataContext
            Dim newItem As New PostItem _
                With {.Author = username, _
                .Description = post.description, _
                .PublicationDate = post.dateCreated, _
                .Title = post.title}
        
            dc.PostItems.InsertOnSubmit(newItem)
            dc.SubmitChanges()
            Return newItem.ID
        End Function

        Private Sub ValidateUser(ByVal username As String, ByVal password As String)
            '   If Not membership.validateuser(username, password) Then
            ' Throw New XmlRpcFaultException(0, "Invalid username/password")
            ' End If
        End Sub
#End Region
    End Class
End Namespace