﻿Imports Microsoft.VisualBasic
Imports System.ServiceModel.Syndication
Imports System.ServiceModel.Activation
Imports LinqBlog.BO

Public Interface IWCFSyndicationService
    Function GetFeed() As SyndicationFeed
End Interface


<AspNetCompatibilityRequirements(RequirementsMode:=AspNetCompatibilityRequirementsMode.Allowed)> _
Public Class WCFSyndicationServiceImplementation
    Implements IWCFSyndicationService


    Public Function GetFeed() As System.ServiceModel.Syndication.SyndicationFeed Implements IWCFSyndicationService.GetFeed
        Dim feed As New SyndicationFeed
        feed.Authors.Add(New SyndicationPerson("Jim Wooley"))
        feed.Description = New TextSyndicationContent("Insights and observations on LINQ and VB")
        feed.Title = New TextSyndicationContent("Wooley's Wonderings")

        Dim dc As New LinqBlogDataContext
        feed.Items = From item In dc.PostItems _
                   Order By item.PublicationDate Descending _
                   Take 10 _
                   Select New SyndicationItem With _
                   {.Summary = New TextSyndicationContent(item.Description), _
                    .LastUpdatedTime = item.PublicationDate, _
                    .PublishDate = item.PublicationDate, _
                    .Title = New TextSyndicationContent(item.Title)}
        Return feed

    End Function
End Class
