Imports System.Xml.Linq
Imports System.Data.Linq
Imports LinqBlog.BO

Partial Class CreateXmlUi
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Response.Buffer = True
        Response.Clear()
        Response.Cache.SetCacheability(HttpCacheability.NoCache)
        Response.ContentType = "text/xml"
        Response.AddHeader("Content-Disposition", "inline;filename=blog.rss")
        CreateXml()
        Response.End()

    End Sub

    Private Sub CreateXml()
        Dim dc As New LinqBlogDataContext
        Dim query = (From p In dc.PostItems _
                    Order By p.PublicationDate Descending _
                    Skip 5 _
                    Take 5 _
                    Select p).ToArray

        Dim foo = <?xml version="1.0" encoding="UTF-8"?>
                  <rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:slash="http://purl.org/rss/1.0/modules/slash/" xmlns:wfw="http://wellformedweb.org/CommentAPI/">
                      <channel>
                          <title>Wooley's Wonderings</title>
                          <link>http://devauthority.com/blogs/jwooley/default.aspx</link>
                          <description>Insights and observations about VB and .Net technologies.</description>
                          <dc:language>en-US</dc:language>
                          <generator>CommunityServer 2.0 (Build: 60217.2664)</generator>
                          <%= From p In query Select <item>
                                                         <title><%= p.Title %></title>
                                                         <link>http://devauthority.com/blogs/jwooley/archive/2007/01/25/21922.aspx</link>
                                                         <pubDate>Fri, 26 Jan 2007 07:51:00 GMT</pubDate>
                                                         <guid isPermaLink="false">42f563c8-34ea-4d01-bfe1-2047c2222a74:21922</guid>
                                                         <description><%= p.Description %>
                                                         </description>
                                                     </item> %>

                      </channel>
                  </rss>

        Response.Write(foo)


    End Sub
End Class
