﻿Imports System
Imports System.Linq
Imports System.Xml.Linq
Imports LinqBlog.BO

Public Module Importer
    Public Sub ImportFeed()
        Dim Feed As System.Xml.Linq.XDocument = XDocument.Load("http://devauthority.com/blogs/jwooley/rss.aspx")
        'Dim FeedPosts = _
        '    From post In Feed...<item> _
        '    Select post

        Dim dc As New LinqBlog.BO.LinqBlogDataContext()

        Dim Categories = (From c In dc.Categories _
            Select c).ToArray

        For Each post As XElement In Feed...<item>
            Dim DataPost As New LinqBlog.BO.PostItem
            DataPost.Author = "Jim Wooley"
            DataPost.Description = post.Element("description").Value
            'DataPost.ID = Integer.Parse(post.Element("guid").Value.Substring(37))
            DataPost.PublicationDate = CDate(post.Element("pubDate").Value)
            DataPost.Title = post.Element("title").Value
            ' Get categories as well
            For Each c As XElement In post...<Category>
                Dim cat = (From dbCat In dc.Categories _
                    Where dbCat.Description = c.Value _
                    Select dbCat).Single
                If Not cat Is Nothing Then
                    Dim catPost As New LinqBlog.BO.CategoryPost
                    catPost.CategoryID = cat.CategoryId
                    catPost.PostId = DataPost.Id
                    DataPost.CategoryPosts.Add(catPost)
                End If
            Next
            dc.PostItems.InsertOnSubmit(DataPost)
            Console.WriteLine(DataPost.Title)
        Next

        dc.SubmitChanges()

        Console.WriteLine()
        Console.ReadLine()
    End Sub
End Module
