Imports LinqBlog.BO
Imports System.Collections.Generic

Partial Class AtomUi
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Response.Buffer = True
        Response.Clear()
        Response.Cache.SetCacheability(HttpCacheability.NoCache)
        Response.ContentType = "text/xml"
        Response.AddHeader("Content-Disposition", "inline;filename=blog.rss")
        WriteRss()
        Response.End()
    End Sub

    Private Sub WriteRss()
        Response.Write("<?xml version='1.0' encoding='UTF-8' ?>")
        Dim dc As New LinqBlogDataContext
        Dim query As IEnumerable(Of PostItem) = (From post In dc.PostItems Select post).ToArray

        Response.Write(<feed xmlns="http://www.w3.org/2005/Atom" xml:lang="en-US">
                           <title type="html">Wooley's Wonderings</title>
                           <subtitle type="html">Insights and observations about VB and .Net technologies.</subtitle>
                           <id>http://devauthority.com/blogs/jwooley/atom.aspx</id>
                           <link rel="alternate" type="text/html" href="http://devauthority.com/blogs/jwooley/default.aspx"/>
                           <link rel="self" type="application/atom+xml" href="http://devauthority.com/blogs/jwooley/atom.aspx"/>
                           <generator uri="http://communityserver.org" version="2.0.60217.2664">Community Server</generator>
                           <updated>2006-10-24T23:52:20Z</updated>
                           <%= From post In query _
                               Select <entry>
                                          <title><%= post.Title %></title>
                                          <link rel="alternate" type="text/html" href=<%= "http://www.thinqlinq.com/Default?Postid=" & post.Id.ToString %>/>
                                          <id>http://devauthority.com/blogs/jwooley/archive/<%= post.Id %>.aspx</id>
                                          <published><%= post.PublicationDate %></published>
                                          <updated><%= post.PublicationDate %></updated>
                                          <content type="html"><%= post.Description %></content>
                                          <author>
                                              <name>jwooley</name>
                                              <uri>http://devauthority.com/members/jwooley.aspx</uri>
                                          </author>
                                      </entry> %>
                       </feed>)

    End Sub
End Class
