Imports LinqBlog.BO
Imports System.Xml.Linq
Imports System.Collections.Generic
Imports <xmlns:ns="http://www.w3.org/2001/XMLSchema">
Imports <xmlns:dc='http://purl.org/dc/elements/1.1/'>
Imports <xmlns:slash='http://purl.org/rss/1.0/modules/slash/'>
Imports <xmlns:wfw='http://wellformedweb.org/CommentAPI/'>

Partial Class Defaultrss
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Response.Buffer = True
        Response.Clear()
        Response.Cache.SetCacheability(HttpCacheability.NoCache)
        Response.ContentType = "text/xml"
        Response.AddHeader("Content-Disposition", "inline;filename=blog.rss")
        WriteRss()
        Response.End()
    End Sub

    Private Sub WriteRss()
        Dim feed = XDocument.Load("http://www.thedatafarm.com/blog/SyndicationService.asmx/GetRssCategory?categoryName=VB")

        Dim posts = From item In feed...<item> _
                    Order By item.<pubDate>.Value Descending _
                    Take 20 _
                    Select New PostItem With _
                    {.Title = item.<title>.Value, _
                     .PublicationDate = item.<pubDate>.Value, _
                     .Description = item.<description>.Value}



        Dim dc As New LinqBlogDataContext
        Dim query = (From post In dc.PostItems Select post).ToList


        Response.Write(<?xml version="1.0" encoding="UTF-8"?>
                       <rss version='2.0' xmlns:dc='http://purl.org/dc/elements/1.1/' xmlns:slash='http://purl.org/rss/1.0/modules/slash/' xmlns:wfw='http://wellformedweb.org/CommentAPI/'>
                           <channel>
                               <title>Wooley's Wonderings</title>
                               <link>http://devauthority.com/blogs/jwooley/default.aspx</link>
                               <description>Insights and observations about VB and .Net technologies.</description>
                               <dc:language>en-US</dc:language>
                               <generator>CommunityServer 2.0 (Build: 60217.2664)</generator>
                               <%= From post In query _
                                   Select <item>
                                              <title><%= post.Title %></title>
                                              <link><%= "http://www.thinqlinq.com/Default?Postid=" & post.Id.ToString %></link>
                                              <pubDate><%= post.PublicationDate %></pubDate>
                                              <guid isPermaLink="false">42f563c8-34ea-4d01-bfe1-2047c2222a74:<%= post.Id %></guid>
                                              <description><%= post.Description %></description>
                                          </item> %>
                           </channel>
                       </rss>)

    End Sub
End Class
